#!/bin/sh

# A simple shell script to test the group name modification to
# PVFS2.
#
# 1. Uses pvfs2-touch to create a file named groupname-file
# 2. Uses pvfs2-ls to list it.
# 3. Checks the attribute with pvfs2-xattr

# Change the following variable if you use some other
# key for storing the group names (document this in
# your turn in.)
GROUP_NAMES_KEY="user.group_names"

# The name of the file created
FILE_NAME="groupname-file"

if [ -z "$1" ]; then
    echo "Usage: $0 <pvfs2 file system mountpoint>"
    exit 1
fi 

echo "Attempting to create file ${1}/$FILE_NAME"
pvfs2-touch ${1}/$FILE_NAME

pvfs2-ls ${1}/$FILE_NAME

echo "Checking extended attribute."
echo pvfs2-xattr -t -k ${GROUP_NAMES_KEY} ${1}/$FILE_NAME
pvfs2-xattr -t -k ${GROUP_NAMES_KEY} ${1}/$FILE_NAME